%define aurox_ver 9.4
%define rel 1

# $Id: alsa-driver.spec,v 1.39 2003/06/17 19:49:06 dude Exp $

# Is this a preversion?
#define prever

# we skip subver when building release (just increase release with new subversion)
#define subver c

# Comma separated list of cards for which to compile a driver
%{!?cards: %{expand: %%define cards all}}

# "uname -r" output of the kernel to build for, the running one
# if none was specified with "--define 'kernel <uname -r>'"
%{!?kernel: %{expand: %%define kernel %(uname -r)}}

%define kversion %(echo %{kernel} | sed -e s/smp// -)
%define krelver  %(echo %{kversion} | tr -s '-' '_')
%if %(echo %{kernel} | grep -c smp)
        %{expand:%%define ksmp -smp}
%endif

Summary: The Advanced Linux Sound Architecture (ALSA) base files.
Name: alsa-driver
Version: 1.0.4
Release: %{aurox_ver}.aur.%{?prever:0.%{prever}.}%{rel}
License: GPL
Group: System Environment/Base
Source0: ftp://ftp.alsa-project.org/pub/driver/%{name}-%{version}%{?prever}%{?subver}.tar.bz2
Source1: alsa-makedev.d.txt
Patch0: alsa-driver-depmod.patch
#Patch1: alsa-driver-0.9.8-serialmidi.patch
URL: http://www.alsa-project.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: kernel-source = %{kversion}, MAKEDEV
#BuildRequires: MAKEDEV

%description
The Advanced Linux Sound Architecture (ALSA) provides audio and MIDI
functionality to the Linux operating system. ALSA has the following
significant features: Efficient support for all types of audio interfaces,
from consumer soundcards to professional multichannel audio interfaces,
fully modularized sound drivers, SMP and thread-safe design, user space
library (alsa-lib) to simplify application programming and provide higher
level functionality as well as support for the older OSS API, providing
binary compatibility for most OSS programs.

This package contains the ALSA /dev entries and basic development files.

Available rpmbuild rebuild options :
--without : isapnp sequencer oss

You may also recompile for given cards only by calling rpmbuild with :
--define "cards card1,card2,card3"
(the default is "cards all")

You may also recompile for a given kernel version and arch with :
--define "kernel <uname -r output>"
(for example "kernel 2.4.20-9")
--define "kpath <path to dir with kernel sources>"
--target <arch>


%package -n kernel%{?ksmp}-module-alsa
Summary: The Advanced Linux Sound Architecture (ALSA) kernel drivers.
Release: %{release}_%{krelver}
Group: System Environment/Kernel
Requires: alsa-driver >= 1.0.0
Requires: kernel%{?ksmp} = %{kversion}, /sbin/depmod
Provides: kernel-modules
%{?ksmp:Provides: kernel-module-alsa = %{version}-%{release}_%{krelver}}

%description -n kernel%{?ksmp}-module-alsa
The Advanced Linux Sound Architecture (ALSA) provides audio and MIDI
functionality to the Linux operating system. ALSA has the following
significant features: Efficient support for all types of audio interfaces,
from consumer soundcards to professional multichannel audio interfaces,
fully modularized sound drivers, SMP and thread-safe design, user space
library (alsa-lib) to simplify application programming and provide higher
level functionality as well as support for the older OSS API, providing
binary compatibility for most OSS programs.

This package contains the ALSA kernel modules for the Linux kernel package.


%package devel
Summary: The Advanced Linux Sound Architecture (ALSA) driver header files.
Group: Development/Libraries

%description devel
The Advanced Linux Sound Architecture (ALSA) provides audio and MIDI
functionality to the Linux operating system. ALSA has the following
significant features: Efficient support for all types of audio interfaces,
from consumer soundcards to professional multichannel audio interfaces,
fully modularized sound drivers, SMP and thread-safe design, user space
library (alsa-lib) to simplify application programming and provide higher
level functionality as well as support for the older OSS API, providing
binary compatibility for most OSS programs.

This package contains the ALSA driver header files.


%prep
%setup -q -n %{name}-%{version}%{?prever}%{?subver}
%patch0 -p1 -b .nodepmod
#%patch1 -p1 -b .serialmidi

# fix issues with workqueue: unresolved symbol schedule_work
rm -f include/linux/workqueue.h

%build
# compiler used for building the Fedora kernel:
CC="gcc32" ; export CC
# We fool configure with these CFLAGS to not have 686 instructions on 386
CFLAGS="-D__module__%{_target_cpu} -D__module__%{kernel_type}" \
%configure \
        --with-kernel=/usr/src/linux-%{kversion} \
        --with-moddir=/lib/modules/%{kernel}/kernel/sound \
        %{?_without_isapnp:--with-isapnp=no} \
        %{!?_without_sequencer:--with-sequencer=yes} \
        %{?_without_oss:--with-oss=no} \
        --with-cards=%{cards}


make %{?_smp_mflags} MODFLAGS="-DMODULE=1 -D__BOOT_KERNEL_H_ -D__MODULE_KERNEL_%{_target_cpu}=1 %{?ksmp:-D__BOOT_KERNEL_SMP=1} %{!?ksmp:-D__BOOT_KERNEL_UP=1}"

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}/etc/rc.d/init.d/
make install \
        IUSER=`id -un` \
        IGROUP=`id -gn` \
        DESTDIR=%{buildroot}

# Install and generate all the device stuff
install -m 644 -D %{SOURCE1} %{buildroot}%{_sysconfdir}/makedev.d/alsa
cp -a %{_sysconfdir}/makedev.d/00macros %{buildroot}%{_sysconfdir}/makedev.d/
rm -f devices

# Create entry list
/dev/MAKEDEV \
        -c %{buildroot}%{_sysconfdir}/makedev.d \
        -d %{buildroot}/dev -M alsa | sed 's|%{buildroot}||g' > device.list

# Remove from the included docs
rm -f doc/Makefile

# Remove for default rpm 4.1 to not fail
rm -f %{buildroot}%{_sysconfdir}/makedev.d/00macros
rm -f %{buildroot}/etc/rc.d/init.d/alsasound

%pre
test -L /dev/snd && rm -f /dev/snd 2>/dev/null 2>&1 || :

%post -n kernel%{?ksmp}-module-alsa
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} >/dev/null 2>&1 || :

%postun -n kernel%{?ksmp}-module-alsa
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} >/dev/null 2>&1 || :

%clean
rm -rf %{buildroot}

%files -f device.list
%defattr(-, root, root)
%doc CARDS-STATUS COPYING FAQ README TODO WARNING
%doc doc/ alsa-kernel/Documentation/*.txt alsa-kernel/Documentation/*.html
%dir /dev/snd
%{_sysconfdir}/makedev.d/alsa

%files devel
%defattr(-, root, root)
%{_includedir}/sound
%doc alsa-kernel/Documentation/DocBook

%files -n kernel%{?ksmp}-module-alsa
%defattr(-, root, root)
/lib/modules/%{kernel}/kernel/sound

%changelog
* Wed May 05 2004 Aurox Team <aurox@aurox.org> 0:1.0.4-9.4.aur.1
- rebuild for new kernel
- new bugfix release 1.0.4
- rebuild for updated kernel
- update to 1.0.3 and rebuild for kernel 2.4.22-1.2174.nptl
- revert to the release 1 and rebuild missing althlon packages
- try new workaround for fedora kernel
- do not build i386 package - we do not ship i386 kernel
- updated release 1.0.2

* Sat Feb 14 2004 Aurox Team <aurox@aurox.org> 0:1.0.2-9.3.aur.1
- do not build i386 package - we do not ship i386 kernel
- updated release 1.0.2

* Tue Dec  9 2003 Matthias Saou <http://freshrpms.net/> - 1.0.0-0.rc2.1.fr
- Update to 1.0.0rc2.
 
* Tue Dec  2 2003 Matthias Saou <http://freshrpms.net/> - 1.0.0-0.rc1.1.fr
- Update to 1.0.0rc1.
- Removed obsolete (yes, again!) Red Hat Linux kernel workaround.

* Mon Nov 24 2003 Matthias Saou <http://freshrpms.net/> - 1.0.0-0.pre2.1.fr
- Update to 1.0.0pre2.

* Sun Nov  2 2003 Matthias Saou <http://freshrpms.net/> - 0.9.8-3.fr
- Rebuild for Fedora Core 1.
- Added a quick and ugly compile fix for serialmidi.c.

* Mon Oct 27 2003 Matthias Saou <http://freshrpms.net/> - 0.9.8-2.fr
- Added workaround to have Red Hat kernel detected with > 2.4.20 too.
- Added workaround to have i386 and i586 modules not compiled with i686 or
  higher CFLAGS.
- Removed the "pre" macro.

* Mon Oct 27 2003 Matthias Saou <http://freshrpms.net/> 0.9.8-1.fr
- Added kernel-modules provides.

* Fri Oct  3 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.7.

* Sun Aug  3 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.6.

* Wed Jul 23 2003 Robert Glowczynski <robertg@software.com.pl> 0.9.4-9.1.aur.3
- Rebuild for kernel 19.9

* Mon Jul 21 2003 Robert Glowczynski <robertg@software.com.pl> 0.9.4-9.1.aur.2
- Update to 0.9.4.
- Header files in separate package - so that we can build packages supporting 
  ALSA without ALSA installed on the development server.

* Thu Jun 12 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.4.
- Removed workqueue workaround, as it's taken care of by configure.
- Changed $CONSOLE to $ALLWRITE in the makedev script...

* Sun May 25 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.3c.
- Major changes in the makedev.d entry for the new devices.

* Fri May  2 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.3a.

* Thu May  1 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.3.
- Renamed alsa-kernel to kernel-module-alsa.

* Mon Mar 31 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Rebuilt for Red Hat Linux 9.

* Wed Mar 19 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.2.

* Mon Mar 17 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Removed now unneeded vmalloc patch.

* Tue Mar 11 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc8d.
- Update to 0.9.1!

* Mon Mar  3 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc8.
- Removed CFLAGS patch, use new MODFLAGS instead.

* Wed Feb 12 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Merge fixes for /sbin/depmod dep and its post/postun scripts.
- Add CFLAGS patch and changes to rebuild for any arch with just the
  right kernel-source installed.
- Minor cleanups inherent to the above.

* Mon Feb  3 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc7.
- Added ability to recompile against non-running kernel.

* Mon Nov 16 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc6.

* Fri Oct 25 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Silent the %%post and %%postun scriplets to avoid unresolved symbol
  warnings during upgrades.

* Wed Oct 23 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc4, then rc5.

* Tue Oct  1 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Removed the dependency about alsa-driver in alsa-kernel to fix apt problems.

* Sun Sep 29 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Added -smp to alsa-kernel packages for SMP systems (needs testing).

* Fri Sep 27 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Moved rpmbuild --without options to the description.
- Rebuild for Red Hat Linux 8.0.
- Fixed the /sbin/depmod -a that was run for the wrong sub-package, doh!

* Tue Sep 17 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed yet another (last?) bug on SMP systems.

* Sun Sep  8 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed build on SMP systems, thanks to Chris Ckloiber.

* Thu Aug 29 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed extra files problem with rpm 4.1.
- Added support for disabling isapnp, sequencer and oss.
- Added support to easily modify to build only drivers for specific cards.
- Simplified the device list creation ("alsa" alias in the makedev.d entry).
- Fixed reversed links in the /dev entries.

* Wed Aug 28 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fix the makedev file that didn't like the CVS tag.
- New sub-package -kernel with only the kernel module (to have multiple
  installations of it easily).
- Fixed kernel arch detection by invoking rpm to query kernel package ;-)

* Tue Aug 27 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Spec file rewrite.
- Added makedev.d stuff to have device files included cleanly.

